"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Notifications = void 0;
var constants_1 = require("../../Helpers/constants");
var urlParams_1 = require("./urlParams");
var Notifications;
(function (Notifications) {
    "use strict";
    /**
     * Initializes the routes.
     *
     * @param app The express app.
     */
    function init(app) {
        app.get("api/mockcsm/:".concat(urlParams_1.UrlParams.Params.subscriptionId, "/{subscriptionId}/providers/microsoft.insights/eventtypes/management/digestEvents"), function (req, res, next) {
            var mockSubscriptionId = req[urlParams_1.UrlParams.Params.subscriptionId];
            if (mockSubscriptionId) {
                var armManager = req.app.armManager;
                var data = {
                    value: armManager.getEvents(mockSubscriptionId)
                };
                res.status(constants_1.Constants.HttpStatusCode.Ok).json(data);
            }
            else {
                next();
            }
        });
        app.get("api/mockcsm/:".concat(urlParams_1.UrlParams.Params.subscriptionId, "/{subscriptionId}/providers/microsoft.insights/eventtypes/management/values"), function (req, res, next) {
            var mockSubscriptionId = req[urlParams_1.UrlParams.Params.subscriptionId];
            if (mockSubscriptionId) {
                var data = {
                    value: []
                };
                res.status(constants_1.Constants.HttpStatusCode.Ok).json(data);
            }
            else {
                next();
            }
        });
    }
    Notifications.init = init;
})(Notifications = exports.Notifications || (exports.Notifications = {}));
//# sourceMappingURL=notifications.js.map