"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UrlParams = void 0;
var constants_1 = require("../../Helpers/constants");
var UrlParams;
(function (UrlParams) {
    "use strict";
    UrlParams.Params = {
        subscriptionId: "subscriptionId",
        resourceGroupId: "resourceGroupId"
    };
    /**
     * Initializes the url param validations.
     */
    function init(app) {
        app.param(UrlParams.Params.subscriptionId, function (req, res, next, param) {
            var armManager = req.app.armManager;
            if (armManager) {
                req[UrlParams.Params.subscriptionId] = armManager.getSubscription(param) && param;
            }
            next();
        });
        app.param(UrlParams.Params.resourceGroupId, function (req, res, next, param) {
            var armManager = req.app.armManager;
            var subId = req[UrlParams.Params.subscriptionId];
            var resourceGroup;
            if (armManager && subId) {
                resourceGroup = req[UrlParams.Params.resourceGroupId] = armManager.getResourceGroup(subId, param) && param;
                if (!resourceGroup) {
                    res.status(constants_1.Constants.HttpStatusCode.NotFound).send("Mock resource group not found.");
                }
            }
            next();
        });
    }
    UrlParams.init = init;
})(UrlParams = exports.UrlParams || (exports.UrlParams = {}));
//# sourceMappingURL=urlParams.js.map