/**
 * Extra properties on a lock
 */
export interface LockProperties {
    /**
     * The lock strength
     */
    level: string;
    /**
     * Notes about the lock
     */
    notes: string;
}
/**
 * The base identifying properties of a lock
 */
export interface LockBase {
    /**
     * The arm resource id the lock is on
     */
    id: string;
    /**
     * The name given to the lock
     */
    name: string;
    /**
     * The lock resource type.
     */
    type: string;
}
/**
 * The data for creation and modification of locks
 */
export interface ArmLockData {
    /**
     * Extra properties on a lock
     */
    properties: LockProperties;
}
/**
 * The resource lock
 */
export interface Lock extends LockBase, ArmLockData {
}
