"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CertHelper = void 0;
var fs = require("fs");
var Q = require("q");
var localHostDns = "localhost";
var CertHelper;
(function (CertHelper) {
    "use strict";
    /**
     * Clears older certificates targeted to localhost, and generates a new certificate. Also
     * places the new certificate in to the local machine store.
     * NOTE: Should be compiled with COMMENTS as this is required to execute PS scripts.
     *
     * @return The generated localhost certificate/
     */
    function createLocalHostSSLOptions() {
        var defered = Q.defer();
        var password = generateRandomPassword();
        var exec = require('child_process').exec;
        var cmd = "\"".concat(__dirname, "\\scripts\\certHelper.cmd\" ").concat(localHostDns, " ").concat(password);
        exec(cmd, function (error, stdout, stderr) {
            if (error) {
                defered.reject("Failed to create certificate.\nError:".concat(error, ",\nSTDOUT:").concat(stdout, ",\nSTDERR:").concat(stderr));
            }
            else {
                try {
                    var outputs = stdout.split(/\r?\n/).filter(function (val) { return !!val; });
                    var ssl = {
                        pfx: fs.readFileSync(outputs[outputs.length - 1]),
                        passphrase: "" + password
                    };
                    defered.resolve(ssl);
                    return;
                }
                catch (err) {
                    error = err;
                }
                defered.reject("Failed to create certificate.\nError:".concat(error));
            }
        });
        return defered.promise;
    }
    CertHelper.createLocalHostSSLOptions = createLocalHostSSLOptions;
    ;
    /**
     * Generates a random string of length 5.
     */
    function generateRandomPassword() {
        return Math.random().toString(36).replace(/[^a-z]+/g, '').substr(0, 5);
    }
})(CertHelper = exports.CertHelper || (exports.CertHelper = {}));
//# sourceMappingURL=certHelper.js.map