import * as Q from "q";
export declare module FirewallHelper {
    /**
     * Adds a firewall rule to open up a local port for node porxy server.
     * NOTE: Should be compiled with COMMENTS as this is required to execute PS scripts.
     *
     * @param name The name of the rule.
     * @param port The local port that is
     * @param overwrite Overwrite existing rule.
     * @return A promise that resolves when the rule is created.
     */
    function addFirewallRule(name: string, port: number, overwrite?: boolean): Q.Promise<any>;
    /**
     * Removes a firewall rule.
     * NOTE: Should be compiled with COMMENTS as this is required to eecute PS scripts.
     *
     * @param name The name of the rule.
     * @return A promise that resolves when the rule is removed.
     */
    function removeFirewallRule(name: string): Q.Promise<any>;
}
