"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
(function () {
    /* %CONFIG */
    // Will be replaced at run-time
    /** @type {PluginConfiguration} */
    var config = {};
    /* CONFIG% */
    // To handle both running in a normal context and within a web worker
    var global = window;
    function getRedirectURL(parsedURL) {
        var originalHost = parsedURL.host;
        // If any of the targeted hosts contains the request's host
        var shouldRedirect = config.hosts.some(function (host) { return originalHost.toUpperCase().includes(host); });
        if (shouldRedirect) {
            parsedURL.protocol = "https";
            parsedURL.host = "localhost:".concat(config.port);
        }
        return [parsedURL, shouldRedirect];
    }
    if (!global.XMLHttpRequest.prototype._realOpen) {
        global.XMLHttpRequest.prototype._realOpen = global.XMLHttpRequest.prototype.open;
        global.XMLHttpRequest.prototype.open = function (method, url, async, user, password) {
            // Parse the URL, using the document's base URI if using a relative URL
            var parsedURL = new global.URL(url, document.baseURI);
            var originalHost = parsedURL.host;
            var _a = getRedirectURL(parsedURL), redirectionURL = _a[0], shouldRedirect = _a[1];
            this._realOpen(method, redirectionURL.toString(), async, user, password);
            if (shouldRedirect) {
                this.setRequestHeader("x-mockfx-run-id" /* RUN_ID */, config.runId);
                this.setRequestHeader("x-mockfx-test-id" /* TEST_ID */, config.testId);
                this.setRequestHeader("x-mockfx-original-host" /* ORIGINAL_HOST */, originalHost);
                this.setRequestHeader("x-mockfx-source" /* SOURCE */, "portal");
            }
        };
    }
    if (!global._realFetch) {
        global._realFetch = global.fetch;
        global.fetch = function (resource, init) {
            var request = new global.Request(resource, init);
            var parsedURL = new global.URL(request.url);
            var originalHost = parsedURL.host;
            var _a = getRedirectURL(parsedURL), redirectionURL = _a[0], shouldRedirect = _a[1];
            if (shouldRedirect) {
                request = new Request(redirectionURL.toString(), request);
                request.headers.set("x-mockfx-run-id" /* RUN_ID */, config.runId);
                request.headers.set("x-mockfx-test-id" /* TEST_ID */, config.testId);
                request.headers.set("x-mockfx-original-host" /* ORIGINAL_HOST */, originalHost);
                request.headers.set("x-mockfx-source" /* SOURCE */, "portal");
            }
            return global._realFetch(request);
        };
    }
})();
//# sourceMappingURL=plugin.js.map