/// <reference types="node" />
import { MockFx } from ".";
import { EventEmitter } from "events";
import { StrictEventEmitter } from 'strict-event-emitter-types';
interface Events {
    log: (level: MockFx.LogLevel, message: string, testContext?: MockFx.Context) => void;
    error: (error: Error, testContext?: MockFx.Context) => void;
    telemetry: (telemetry: MockFx.Telemetry) => void;
    finalizeStage: (data: MockFx.Stage) => void;
    finalizeTest: (data: MockFx.Finalization) => void;
    registerStage: (data: MockFx.Stage) => void;
    registerTest: (data: MockFx.Context) => void;
}
declare class Logger extends EventEmitter {
    constructor();
    debug(message: string, testContext?: MockFx.Context): void;
    info(message: string, testContext?: MockFx.Context): void;
    warn(message: string, testContext?: MockFx.Context): void;
    error(error: Error, testContext?: MockFx.Context): void;
    telemetry(telemetry: MockFx.Telemetry): void;
    finalizeStage(data: MockFx.Stage): void;
    finalizeTest(data: MockFx.Finalization): void;
    registerStage(data: MockFx.Stage): void;
    registerTest(data: MockFx.Context): void;
}
export declare type LoggerType = StrictEventEmitter<Logger, Events>;
export declare const logger: LoggerType;
export {};
