"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.logger = void 0;
var events_1 = require("events");
var Logger = /** @class */ (function (_super) {
    __extends(Logger, _super);
    function Logger() {
        return _super.call(this) || this;
    }
    Logger.prototype.debug = function (message, testContext) {
        this.emit("log" /* Log */, "debug" /* Debug */, message, testContext);
    };
    Logger.prototype.info = function (message, testContext) {
        this.emit("log" /* Log */, "info" /* Info */, message, testContext);
    };
    Logger.prototype.warn = function (message, testContext) {
        this.emit("log" /* Log */, "warn" /* Warn */, message, testContext);
    };
    Logger.prototype.error = function (error, testContext) {
        this.emit("error" /* Error */, error, testContext);
    };
    Logger.prototype.telemetry = function (telemetry) {
        this.emit("telemetry" /* Telemetry */, telemetry);
    };
    Logger.prototype.finalizeStage = function (data) {
        this.emit("finalizeStage" /* FinalizeStage */, data);
    };
    Logger.prototype.finalizeTest = function (data) {
        this.emit("finalizeTest" /* FinalizeTest */, data);
    };
    Logger.prototype.registerStage = function (data) {
        this.emit("registerStage" /* RegisterStage */, data);
    };
    Logger.prototype.registerTest = function (data) {
        this.emit("registerTest" /* RegisterTest */, data);
    };
    return Logger;
}(events_1.EventEmitter));
exports.logger = new Logger();
//# sourceMappingURL=logger.js.map