"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseRawHeaders = exports.request = exports.createProxy = exports.stopServer = exports.createHTTPSServer = exports.getServerOptions = void 0;
var http_proxy_1 = require("http-proxy");
var https_1 = require("https");
var rawBody = require("raw-body");
var logger_1 = require("../logger");
var system_1 = require("../system");
var serverOptions;
function getServerOptions(certificate) {
    return __assign(__assign({}, certificate), { minVersion: "TLSv1.2" });
}
exports.getServerOptions = getServerOptions;
function createHTTPSServer(app, serverOptions, port) {
    return __awaiter(this, void 0, void 0, function () {
        var server_1, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    logger_1.logger.debug("Creating HTTPS server at ".concat(port));
                    server_1 = (0, https_1.createServer)(serverOptions, app);
                    return [4 /*yield*/, (0, system_1.addFirewallRule)(port)];
                case 1:
                    _a.sent();
                    server_1.on("close", function () {
                        logger_1.logger.info("MockFx server stopped");
                    });
                    return [2 /*return*/, new Promise(function (resolve, reject) {
                            server_1.on("error", reject);
                            server_1.listen(port, function () {
                                logger_1.logger.info("MockFx server listening at https://localhost:".concat(port));
                                resolve(server_1);
                            });
                        })];
                case 2:
                    error_1 = _a.sent();
                    logger_1.logger.error(error_1);
                    throw error_1;
                case 3: return [2 /*return*/];
            }
        });
    });
}
exports.createHTTPSServer = createHTTPSServer;
function stopServer(server) {
    return __awaiter(this, void 0, void 0, function () {
        var error_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!server) return [3 /*break*/, 4];
                    server.close();
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, (0, system_1.removeFirewallRule)()];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    error_2 = _a.sent();
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.stopServer = stopServer;
function createProxy(host, serverOptions, responseCb, getMetadata, parseResponse) {
    var proxy = (0, http_proxy_1.createProxyServer)({
        ssl: serverOptions,
        target: "https://" + host,
        agent: https_1.globalAgent,
        changeOrigin: true,
        preserveHeaderKeyCase: true,
        headers: {
            host: host,
        },
    });
    /**
     * We're catching the proxyReq event in order to modify the request before it gets sent to the proxy.
     *
     * We need to turn off compression so that we can process the response easier, and make sure thre request body
     * is a string and that the content-length header is set appropriately.
     */
    proxy.on("proxyReq", function (proxyReq, req) {
        try {
            var request_1 = req;
            if (!proxyReq.headersSent) {
                // Tells resource not to compress response
                proxyReq.removeHeader("accept-encoding");
            }
            if (request_1.body) {
                var body = request_1.body;
                if (typeof body === 'object' && !Buffer.isBuffer(body)) {
                    body = JSON.stringify(body);
                }
                proxyReq.setHeader("Content-Length", Buffer.byteLength(body));
                proxyReq.write(body);
            }
        }
        catch (error) {
            logger_1.logger.error(error);
        }
    });
    /**
     * Process the response from the proxy into a MockFx.Request object to send through the targets
     */
    proxy.on("proxyRes", function (proxyRes, req) {
        return __awaiter(this, void 0, void 0, function () {
            var request_2, responseBody, err_1, responseHeaders, metadata, _a, response, _b, mockRequest, err_2, error_3;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _c.trys.push([0, 14, , 15]);
                        request_2 = req;
                        responseBody = void 0;
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, rawBody(proxyRes)];
                    case 2:
                        responseBody = _c.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _c.sent();
                        throw new Error("Could not extract body from response: ".concat(err_1));
                    case 4:
                        _c.trys.push([4, 12, , 13]);
                        responseHeaders = parseRawHeaders(proxyRes.rawHeaders);
                        if (!getMetadata) return [3 /*break*/, 6];
                        return [4 /*yield*/, getMetadata(request_2, proxyRes)];
                    case 5:
                        _a = _c.sent();
                        return [3 /*break*/, 7];
                    case 6:
                        _a = {};
                        _c.label = 7;
                    case 7:
                        metadata = _a;
                        if (!parseResponse) return [3 /*break*/, 9];
                        return [4 /*yield*/, parseResponse(proxyRes, responseBody)];
                    case 8:
                        _b = _c.sent();
                        return [3 /*break*/, 10];
                    case 9:
                        _b = responseBody.length
                            ? {
                                __type: "buffer",
                                content: responseBody.toString("base64"),
                            }
                            : undefined;
                        _c.label = 10;
                    case 10:
                        response = _b;
                        mockRequest = {
                            url: request_2.url,
                            method: request_2.method,
                            metadata: metadata,
                            request: request_2.body,
                            response: response,
                            responseHeaders: responseHeaders,
                            responseCode: proxyRes.statusCode || -1,
                            responseSize: getResponseSize(responseHeaders),
                        };
                        return [4 /*yield*/, responseCb(req, mockRequest)];
                    case 11:
                        _c.sent();
                        return [3 /*break*/, 13];
                    case 12:
                        err_2 = _c.sent();
                        throw new Error("Could not process response.");
                    case 13: return [3 /*break*/, 15];
                    case 14:
                        error_3 = _c.sent();
                        logger_1.logger.error(error_3);
                        return [3 /*break*/, 15];
                    case 15: return [2 /*return*/];
                }
            });
        });
    });
    proxy.on("error", function (err, req, res) {
        res.writeHead(500, {
            "Content-Type": "text/plain",
        });
        logger_1.logger.error(err);
        res.end("Something went wrong: " + err);
    });
    proxy.on("close", function () {
        logger_1.logger.info("".concat(host, " proxy disconnected"));
    });
    proxy.on("econnreset", function (error) {
        // listen for messages coming FROM the target here
        logger_1.logger.error(error);
    });
    return {
        send: function (req, res) {
            // The target name was added to the URL in order to send it through the Express
            // routers, but we need to remove it before sending to the proxy
            var targetName = req.headers["x-mockfx-target" /* TARGET */];
            req.url = req.url.replace(new RegExp("/".concat(targetName)), "");
            if (req.method === "GET") {
                req.body = undefined;
            }
            logger_1.logger.debug("Sending request to ".concat(targetName, " for ").concat(req.url));
            proxy.web(req, res);
        },
        close: proxy.close,
    };
}
exports.createProxy = createProxy;
function request(url, method, headers, data) {
    if (method === void 0) { method = 'GET'; }
    if (headers === void 0) { headers = {}; }
    return __awaiter(this, void 0, void 0, function () {
        var certificate, headersRecord;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!!serverOptions) return [3 /*break*/, 2];
                    return [4 /*yield*/, (0, system_1.getSSLCertificate)()];
                case 1:
                    certificate = _a.sent();
                    serverOptions = getServerOptions(certificate);
                    _a.label = 2;
                case 2:
                    headersRecord = CaseInsensitiveRecord(headers);
                    // Set Content-Length for PUT/POST
                    if (/^(post|put|patch)$/i.test(method)) {
                        if (data === undefined || data === null) {
                            data = undefined;
                            headersRecord.set('Content-Length', '0');
                        }
                        else {
                            headersRecord.set('Content-Length', data.length.toString());
                        }
                    }
                    else {
                        // Remove content headers for non PUT/POST
                        data = undefined;
                        headersRecord.delete('Content-Length');
                        headersRecord.delete('Content-Type');
                    }
                    // Turn off compression
                    headersRecord.delete('Accept-Encoding');
                    return [2 /*return*/, new Promise(function (resolve) {
                            var request = (0, https_1.request)(url, __assign({ method: method, headers: headers, agent: https_1.globalAgent }, serverOptions), function (response) {
                                rawBody(response, function (error, body) {
                                    if (error) {
                                        console.error(error);
                                        return resolve({
                                            statusCode: 500,
                                            body: Buffer.from(error.message)
                                        });
                                    }
                                    resolve({
                                        statusCode: response.statusCode,
                                        headers: parseRawHeaders(response.rawHeaders),
                                        body: body.length ? body : undefined
                                    });
                                });
                            });
                            request.on("error", function (error) {
                                console.error(error);
                                resolve({
                                    statusCode: 500,
                                    body: Buffer.from(error.message)
                                });
                            });
                            if (data) {
                                request.write(data);
                            }
                            request.end();
                        })];
            }
        });
    });
}
exports.request = request;
// Creates map with case-insensitive key operations
function CaseInsensitiveRecord(record) {
    var keyMap = new Map();
    Object.keys(record).forEach((function (key) { return keyMap.set(key.toLowerCase(), key); }));
    return {
        get: function (key) {
            return record[keyMap.get(key.toLowerCase())];
        },
        set: function (key, value) {
            var realKey = keyMap.has(key.toLowerCase())
                ? keyMap.get(key.toLowerCase())
                : keyMap.set(key.toLowerCase(), key) && key;
            record[realKey] = value;
            return record;
        },
        delete: function (key) {
            var realKey = keyMap.get(key.toLowerCase());
            if (realKey) {
                delete record[realKey];
                keyMap.delete(key.toLowerCase());
                return true;
            }
            return false;
        }
    };
}
/**
 * Parses a message's rawHeaders array into an object in order to preserve casing.
 *
 * @export
 * @param {string[]} rawHeaders
 * @returns {Record<string, string>}
 */
function parseRawHeaders(rawHeaders) {
    if (rawHeaders.length % 2 !== 0) {
        throw new Error("Raw headers must be of even length.");
    }
    var headers = {};
    for (var i = 0; i < rawHeaders.length; i += 2) {
        headers[rawHeaders[i]] = rawHeaders[i + 1];
    }
    return headers;
}
exports.parseRawHeaders = parseRawHeaders;
function getResponseSize(headers) {
    var lengthKey = Object.keys(headers).find(function (header) { return header.toUpperCase() === 'CONTENT-LENGTH'; });
    if (lengthKey) {
        return parseInt(headers[lengthKey]);
    }
    return 0;
}
//# sourceMappingURL=index.js.map