"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.batchRouter = void 0;
var express_1 = require("express");
var url_1 = require("url");
var server_1 = require("../../server");
exports.batchRouter = (0, express_1.Router)();
exports.batchRouter.post("/", function (req, res, next) { return __awaiter(void 0, void 0, void 0, function () {
    var body_1, requests;
    return __generator(this, function (_a) {
        try {
            body_1 = req.body;
            if (body_1 && body_1.requests) {
                requests = body_1.requests.map(function (batchRequest) { return __awaiter(void 0, void 0, void 0, function () {
                    var host, path, parsedUrl, url, method, headers, response, content, data;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                host = req.get("host");
                                path = batchRequest.relativeUrl || batchRequest.url || "";
                                if (path.includes("://")) {
                                    parsedUrl = (0, url_1.parse)(path);
                                    path = parsedUrl.href ? parsedUrl.href.replace(parsedUrl.protocol + "//" + parsedUrl.host, "") : "";
                                }
                                path = encodeRequestURL(path);
                                url = "".concat(req.protocol, "://").concat(host).concat(path);
                                method = batchRequest.httpMethod;
                                headers = __assign(__assign(__assign({}, (0, server_1.parseRawHeaders)(req.rawHeaders)), batchRequest.requestHeaderDetails), getBodyHeaders(body_1.headers));
                                return [4 /*yield*/, (0, server_1.request)(url, method, headers, batchRequest.content && Buffer.from(JSON.stringify(batchRequest.content)))];
                            case 1:
                                response = _a.sent();
                                content = response.body && response.body.toString('utf8');
                                if (response.statusCode < 300) {
                                    if (typeof content === 'string' && content.length) {
                                        try {
                                            content = JSON.parse(content);
                                        }
                                        catch (_b) {
                                            console.error("Unable to parse ARM batch response as JSON:", { url: url, responseBody: content });
                                        }
                                    }
                                    return [2 /*return*/, {
                                            httpStatusCode: response.statusCode,
                                            headers: response.headers,
                                            content: content,
                                            name: batchRequest.name
                                        }];
                                }
                                else {
                                    data = { message: content };
                                    if (typeof content === 'string' && content.length) {
                                        try {
                                            data = JSON.parse(content);
                                        }
                                        catch (_c) {
                                            console.error("Unable to parse ARM batch response as JSON:", { url: url, responseBody: content });
                                        }
                                    }
                                    return [2 /*return*/, {
                                            httpStatusCode: response.statusCode,
                                            headers: response.headers,
                                            content: data,
                                            name: batchRequest.name
                                        }];
                                }
                                return [2 /*return*/];
                        }
                    });
                }); });
                Promise.all(requests)
                    .then(function (responses) {
                    res.status(200).json({ responses: responses });
                })
                    .catch(function (error) { return next(error); });
            }
            else {
                next();
            }
        }
        catch (error) {
            next(error);
        }
        return [2 /*return*/];
    });
}); });
function encodeRequestURL(url) {
    // Alphanumerics, -._~!$'()*+,;:@/? symbols, and percent-encoded characters (e.g. %25) do not need to be encoded in query parameters
    // If the parameter values only include these characters, no need to encode. Prevents encoding already-encoded URLs
    // https://stackoverflow.com/a/49400367
    var validQueryParameterValue = /^([a-zA-Z0-9\-._~!$'()*+,;:@/?]|%[a-fA-F0-9]{2})*$/;
    var path = url.indexOf("?") !== -1 ? url.substr(0, url.indexOf("?")) : url;
    var query = url.indexOf("?") !== -1 ? url.substr(url.indexOf("?") + 1) : "";
    if (query) {
        var params = query
            .split("&")
            .map(function (param) {
            var name = param.substr(0, param.indexOf("="));
            var value = param.substr(param.indexOf("=") + 1);
            return "".concat(name, "=").concat(validQueryParameterValue.test(value) ? value : encodeURIComponent(value));
        })
            .join("&");
        url = "".concat(path, "?").concat(params);
    }
    return url;
}
function getBodyHeaders(headers) {
    if (!headers) {
        return {};
    }
    return Object.keys(headers).reduce(function (acc, header) {
        acc[header] = headers[header][0];
        return acc;
    }, {});
}
//# sourceMappingURL=batch.js.map