import { Request } from "express";
import { MockFx } from "../..";
export interface ARMDefinitionConfiguration extends Pick<MockFx.TargetDefinition, "loadRequests" | "storeRequests" | "onBeforeRequestMatch"> {
    host: string;
    /**
     * *Replay mode*
     *
     * Called on incoming request to match it against a stored request
     *
     * @param {Express.Request} request - the incoming request
     * @param {string} normalizedUrl - the normalized URL for the incoming request with
     * @param {MockFx.Request[]} mockRequest - the stored mock request to compare against the incoming request
     * @param {MockFx.Context} context - the mock context object for the currently running test
     * @returns {boolean} if the stored mock request matches the incoming request
     */
    customMatchRequest?: (request: Request, normalizedUrl: string, mockRequest: MockFx.Request, context: MockFx.Context) => boolean;
}
export declare function getNormalizedUrl(url: string): string;
export declare function createARMTarget({ host, loadRequests, storeRequests, onBeforeRequestMatch, customMatchRequest }: ARMDefinitionConfiguration): MockFx.TargetDefinition;
