"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.invokeRouter = void 0;
var express_1 = require("express");
var url_1 = require("url");
var server_1 = require("../../server");
var xmsPathQuery = "x-ms-path-query";
exports.invokeRouter = (0, express_1.Router)();
exports.invokeRouter.all("/", function (req, res, next) { return __awaiter(void 0, void 0, void 0, function () {
    var host, path, parsedUrl, url, method, headers, response, error_1;
    var _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _b.trys.push([0, 2, , 3]);
                host = req.get("host");
                path = req.headers[xmsPathQuery];
                if (path.includes("://")) {
                    parsedUrl = (0, url_1.parse)(path);
                    path = parsedUrl.href ? parsedUrl.href.replace(parsedUrl.protocol + "//" + parsedUrl.host, "") : "";
                }
                path = encodeRequestURL(path);
                url = "".concat(req.protocol, "://").concat(host).concat(path);
                method = req.method;
                headers = (0, server_1.parseRawHeaders)(req.rawHeaders);
                delete headers[xmsPathQuery];
                return [4 /*yield*/, (0, server_1.request)(url, method, headers, req.body && Buffer.from(JSON.stringify(req.body)))];
            case 1:
                response = _b.sent();
                return [2 /*return*/, res.status(response.statusCode).send((_a = response.body) === null || _a === void 0 ? void 0 : _a.toString('utf8'))];
            case 2:
                error_1 = _b.sent();
                next(error_1);
                return [3 /*break*/, 3];
            case 3: return [2 /*return*/];
        }
    });
}); });
function encodeRequestURL(url) {
    // Alphanumerics, -._~!$'()*+,;:@/? symbols, and percent-encoded characters (e.g. %25) do not need to be encoded in query parameters
    // If the parameter values only include these characters, no need to encode. Prevents encoding already-encoded URLs
    // https://stackoverflow.com/a/49400367
    var validQueryParameterValue = /^([a-zA-Z0-9\-._~!$'()*+,;:@/?]|%[a-fA-F0-9]{2})*$/;
    var path = url.indexOf("?") !== -1 ? url.substr(0, url.indexOf("?")) : url;
    var query = url.indexOf("?") !== -1 ? url.substr(url.indexOf("?") + 1) : "";
    if (query) {
        var params = query
            .split("&")
            .map(function (param) {
            var name = param.substr(0, param.indexOf("="));
            var value = param.substr(param.indexOf("=") + 1);
            return "".concat(name, "=").concat(validQueryParameterValue.test(value) ? value : encodeURIComponent(value));
        })
            .join("&");
        url = "".concat(path, "?").concat(params);
    }
    return url;
}
//# sourceMappingURL=invoke.js.map