import { MockFx } from "..";
/**
 * Tests whether two urls have different api versions but are otherwise identical, e.g.
 * urlsAreSameApartFromApiVersion("sameUrl?api-version=2021-10-01", "sameUrl?api-version=2019-09-01") returns true;
 * urlsAreSameApartFromApiVersion("sameUrl?api-version=2021-10-01", "sameUrl?api-version=2021-10-01") returns false.
 *
 * @param url1
 * @param url2
 * @returns
 */
export declare function urlsAreSameApartFromApiVersion(url1: string, url2: string): boolean;
/**
 * Logs error when urls of mock request and proxied request have different api versions but are otherwise the same
 *
 * @param url1
 * @param url2
 * @param partialMessage provide additional information about requests/matching
 * @returns
 */
export declare function logErrorIfRequestsDifferOnlyInApiVersion(url1: string, url2: string, partialMessage: string, context: MockFx.Context): void;
