"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UrlParams = void 0;
var UrlParams;
(function (UrlParams) {
    "use strict";
    UrlParams.Params = {
        subscriptionId: "subscriptionId",
        thumbprint: "thumbprint"
    };
    /**
     * Initializes the url param validations.
     */
    function init(app) {
        app.param(UrlParams.Params.subscriptionId, function (req, res, next, param) {
            var rdfeManager = req.app.rdfeManager;
            // Verifies that the subscription does exist in our list of subscriptions available for Management Certificate operations.
            if (rdfeManager) {
                req[UrlParams.Params.subscriptionId] = rdfeManager.getSubscription(param) && param;
            }
            next();
        });
        app.param(UrlParams.Params.thumbprint, function (req, res, next, param) {
            var rdfeManager = req.app.rdfeManager;
            if (rdfeManager) {
                req[UrlParams.Params.thumbprint] = param;
            }
            next();
        });
    }
    UrlParams.init = init;
})(UrlParams = exports.UrlParams || (exports.UrlParams = {}));
//# sourceMappingURL=urlParams.js.map