export interface SubscriptionCertificate {
    /**
     * Specifies a base-64 encoded public key for the management certificate.
     */
    subscriptionCertificatePublicKey: string;
    /**
     * Specifies the thumbprint of the management certificate.
     */
    subscriptionCertificateThumbprint: string;
    /**
     * Specifies the base-64 encoded data contained in the management certificate, in .cer format.
     */
    subscriptionCertificateData: string;
    /**
     * Specifies the time that the management certificate was created, in UTC. An example Created value is 2011-05-11T16:15:26Z.
     */
    created: Date;
}
